local BS = AceLibrary("Babble-Spell-2.2");
local L = AceLibrary("AceLocale-2.2"):new("SorrenTimers");

local AirTotems = {
	[BS["Windfury Totem"] ] = true, 
	[BS["Windwall Totem"] ] = true, 
	[BS["Grace of Air Totem"] ] = true, 
	[BS["Nature Resistance Totem"] ] = true, 
	[BS["Grounding Totem"] ] = true, 
	[BS["Sentry Totem"] ] = true,
	[BS["Tranquil Air Totem"] ] = true,
};
local FireTotems = {
	[BS["Frost Resistance Totem"] ] = true, 
	[BS["Flametongue Totem"] ] = true, 
	[BS["Magma Totem"] ] = true, 
	[BS["Searing Totem"] ] = true,
	[BS["Fire Nova Totem"] ] = true,
	[BS["Fire Elemental Totem"] ] = true,
};
local EarthTotems = {
	[BS["Tremor Totem"] ] = true, 
	[BS["Stoneskin Totem"] ] = true, 
	[BS["Strength of Earth Totem"] ] = true, 
	[BS["Earthbind Totem"] ] = true,
	[BS["Stoneclaw Totem"] ] = true,
	[BS["Earth Elemental Totem"] ] = true,
};
local WaterTotems = {
	[BS["Healing Stream Totem"] ] = true, 
	[BS["Mana Spring Totem"] ] = true, 
	[BS["Poison Cleansing Totem"] ] = true, 
	[BS["Disease Cleansing Totem"] ] = true,
	[BS["Fire Resistance Totem"] ] = true,
};

function SorrenTimers:SetShaman()
	return {
		useActionSkills = {
			[BS["Windfury Totem"] ] = {
				duration = 120,
			}, 
			[BS["Windwall Totem"] ] = {
				duration = 120,
			}, 
			[BS["Grace of Air Totem"] ] = {
				duration = 120,
			}, 
			[BS["Nature Resistance Totem"] ] = {
				duration = 120,
			}, 
			[BS["Grounding Totem"] ] = {
				duration = 120,
			}, 
			[BS["Sentry Totem"] ] = {
				duration = 120,
			},
			[BS["Tranquil Air Totem"] ] = {
				duration = 120,
			},
			[BS["Frost Resistance Totem"] ] = {
				duration = 120,
			}, 
			[BS["Flametongue Totem"] ] = {
				duration = 120,
			}, 
			[BS["Magma Totem"] ] = {
				duration = 20,
			}, 
			[BS["Searing Totem"] ] = {
				duration = 35,
			},
			[BS["Fire Nova Totem"] ] = {
				duration = 5,
			},
			[BS["Fire Elemental Totem"] ] = {
				duration = 120,
			},
			[BS["Tremor Totem"] ] = {
				duration = 120,
			}, 
			[BS["Stoneskin Totem"] ] = {
				duration = 120,
			}, 
			[BS["Strength of Earth Totem"] ] = {
				duration = 120,
			}, 
			[BS["Earthbind Totem"] ] = {
				duration = 45,
			},
			[BS["Stoneclaw Totem"] ] = {
				duration = 15,
			},
			[BS["Earth Elemental Totem"] ] = {
				duration = 120,
			},
			[BS["Healing Stream Totem"] ] = {
				duration = 120,
			}, 
			[BS["Mana Spring Totem"] ] = {
				duration = 120,
			}, 
			[BS["Poison Cleansing Totem"] ] = {
				duration = 120,
			}, 
			[BS["Disease Cleansing Totem"] ] = {
				duration = 120,
			},
			[BS["Fire Resistance Totem"] ] = {
				duration = 120,
			},
		},
		stops = {
			[BS["Windfury Totem"] ] = AirTotems, 
			[BS["Windwall Totem"] ] = AirTotems, 
			[BS["Grace of Air Totem"] ] = AirTotems, 
			[BS["Nature Resistance Totem"] ] = AirTotems, 
			[BS["Grounding Totem"] ] = AirTotems, 
			[BS["Sentry Totem"] ] = AirTotems,
			[BS["Tranquil Air Totem"] ] = AirTotems,
			[BS["Frost Resistance Totem"] ] = FireTotems, 
			[BS["Flametongue Totem"] ] = FireTotems, 
			[BS["Magma Totem"] ] = FireTotems, 
			[BS["Searing Totem"] ] = FireTotems,
			[BS["Fire Nova Totem"] ] = FireTotems,
			[BS["Fire Elemental Totem"] ] = FireTotems,
			[BS["Tremor Totem"] ] = EarthTotems, 
			[BS["Stoneskin Totem"] ] = EarthTotems, 
			[BS["Strength of Earth Totem"] ] = EarthTotems, 
			[BS["Earthbind Totem"] ] = EarthTotems,
			[BS["Stoneclaw Totem"] ] = EarthTotems,
			[BS["Earth Elemental Totem"] ] = EarthTotems,
			[BS["Healing Stream Totem"] ] = WaterTotems, 
			[BS["Mana Spring Totem"] ] = WaterTotems, 
			[BS["Poison Cleansing Totem"] ] = WaterTotems, 
			[BS["Disease Cleansing Totem"] ] = WaterTotems,
			[BS["Fire Resistance Totem"] ] = WaterTotems,
		},
		totems = {
			[BS["Windfury Totem"] ] = true, 
			[BS["Windwall Totem"] ] = BS["Windwall"], 
			[BS["Grace of Air Totem"] ] = BS["Grace of Air"], 
			[BS["Nature Resistance Totem"] ] = BS["Nature Resistance"], 
			[BS["Grounding Totem"] ] = BS["Grounding Totem Effect"], 
			[BS["Sentry Totem"] ] = true,
			[BS["Tranquil Air Totem"] ] = BS["Tranquil Air"],
			[BS["Frost Resistance Totem"] ] = BS["Frost Resistance"], 
			[BS["Flametongue Totem"] ] = true, 
			[BS["Magma Totem"] ] = true, 
			[BS["Searing Totem"] ] = true,
			[BS["Fire Nova Totem"] ] = true,
			[BS["Fire Elemental Totem"] ] = true,
			[BS["Tremor Totem"] ] = true, 
			[BS["Stoneskin Totem"] ] = BS["Stoneskin"], 
			[BS["Strength of Earth Totem"] ] = BS["Strength of Earth"], 
			[BS["Earthbind Totem"] ] = true,
			[BS["Stoneclaw Totem"] ] = true,
			[BS["Earth Elemental Totem"] ] = true,
			[BS["Healing Stream Totem"] ] = BS["Healing Stream"], 
			[BS["Mana Spring Totem"] ] = BS["Mana Spring"], 
			[BS["Poison Cleansing Totem"] ] = true, 
			[BS["Disease Cleansing Totem"] ] = true,
			[BS["Fire Resistance Totem"] ] = BS["Fire Resistance"],
		},
		interrupts = {
			[BS["Earth Shock"] ] = {
				duration = 2,
			},
		},
		diminish = {
			[BS["Frost Shock"] ] = BS["Frost Shock"],
		},
	}, BS["Rockbiter Weapon"];
end
